diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 79ccb7266..6d099f075 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -35,6 +35,7 @@ import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.client.render.block.model.BlockModelGrass;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.font.FontRendererDefault;
+import net.minecraft.client.render.terrain.TerrainRendererMultiDraw;
 import net.minecraft.client.util.helper.UrlHelper;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
@@ -512,18 +513,18 @@ public class Minecraft
 		
         OpenGLHelper.testCapabilities(this);
         
-//        if(gameSettings.enableMultiDrawRendering.value) {
-//            if(OpenGLHelper.gl20) {
-//            	System.out.println("Using MultiDraw terrain renderer");
-//            	terrainRenderer = new TerrainRendererMultiDraw(this);
-//            }else {
-//            	System.out.println("MultiDraw not supported, using legacy terrain renderer");
-//            	terrainRenderer = new TerrainRendererLegacy(this);
-//            }
-//        }else {
-//        	System.out.println("MultiDraw disabled, using legacy terrain renderer");
+        if(gameSettings.enableMultiDrawRendering.value) {
+            if(OpenGLHelper.gl20) {
+            	System.out.println("Using MultiDraw terrain renderer");
+            	terrainRenderer = new TerrainRendererMultiDraw(this);
+            }else {
+            	System.out.println("MultiDraw not supported, using legacy terrain renderer");
+            	terrainRenderer = new TerrainRendererLegacy(this);
+            }
+        }else {
+        	System.out.println("MultiDraw disabled, using legacy terrain renderer");
         	terrainRenderer = new TerrainRendererLegacy(this);
-//        }
+        }
         
         if(Shaders.enableShaders) {
             setRenderer(new ShadersRenderer(this));
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index b7d7c0ca6..0c2126d44 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -44,13 +44,15 @@ public class ScreenSignEditor extends Screen
         buttons.add(new ButtonElement(1, width / 2 - 20, 120 + 50 + yOffset, 20, 20, "<"));
         buttons.add(new ButtonElement(2, width / 2, 120 + 50 + yOffset, 20, 20, ">"));
 
-        add(new ListenerButtonElement(30, width/2 - 50, 12 * 0 + 67 + ((entitySign.getBlockId() == Blocks.SIGN_WALL_PLANKS_OAK.id()) ? 31 : 0), 100, 12, "")
+        boolean wallSign = !((BlockLogicSign) block.getLogic()).isFreeStanding;
+
+        add(new ListenerButtonElement(30, width/2 - 50, 12 * 0 + 67 + (wallSign ? 31 : 0), 100, 12, "")
             .setActionListener(() -> {editLine = 0; inKeyboard = true;})).mute().hide();
-        add(new ListenerButtonElement(30, width/2 - 50, 12 * 1 + 67 + ((entitySign.getBlockId() == Blocks.SIGN_WALL_PLANKS_OAK.id()) ? 31 : 0), 100, 12, "")
+        add(new ListenerButtonElement(30, width/2 - 50, 12 * 1 + 67 + (wallSign ? 31 : 0), 100, 12, "")
             .setActionListener(() -> {editLine = 1;inKeyboard = true;})).mute().hide();
-        add(new ListenerButtonElement(30, width/2 - 50, 12 * 2 + 67 + ((entitySign.getBlockId() == Blocks.SIGN_WALL_PLANKS_OAK.id()) ? 31 : 0), 100, 12, "")
+        add(new ListenerButtonElement(30, width/2 - 50, 12 * 2 + 67 + (wallSign ? 31 : 0), 100, 12, "")
             .setActionListener(() -> {editLine = 2;inKeyboard = true;})).mute().hide();
-        add(new ListenerButtonElement(30, width/2 - 50, 12 * 3 + 67 + ((entitySign.getBlockId() == Blocks.SIGN_WALL_PLANKS_OAK.id()) ? 31 : 0), 100, 12, "")
+        add(new ListenerButtonElement(30, width/2 - 50, 12 * 3 + 67 + (wallSign ? 31 : 0), 100, 12, "")
             .setActionListener(() -> {editLine = 3;inKeyboard = true;})).mute().hide();
 
         inKeyboard = (mc.gameSettings.forceOnscreenKeyboard.value || mc.inputType == InputType.CONTROLLER) && !(mc.currentScreen instanceof ScreenKeyboard);
@@ -159,7 +161,7 @@ public class ScreenSignEditor extends Screen
         GL11.glScalef(-scale, -scale, -scale);
         GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
         Block<?> block = entitySign.getBlock();
-        if(block == Blocks.SIGN_POST_PLANKS_OAK)
+        if(((BlockLogicSign) block.getLogic()).isFreeStanding)
         {
             float signAngle = (float)((entitySign.getBlockMeta() & BlockLogicSign.MASK_SIDE) * 360) / 16F;
             GL11.glRotatef(signAngle, 0.0F, 1.0F, 0.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
index ee3951f92..26deddd45 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
@@ -302,7 +302,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory<ViewerCategoryBlock
         mc.currentWorld.markBlockDirty(DisplayChunk.displayBlockPosX, DisplayChunk.displayBlockPosY, DisplayChunk.displayBlockPosZ);
     }
 
-    public static class BlockRenderInfo extends Info {
+    public static class BlockRenderInfo extends ModelViewerCategory.Info {
         final @NotNull File outputDir;
         final int blockId;
         final int blockMeta;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
index 6784fb64e..83c3b7998 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
@@ -33,6 +33,8 @@ public class ScreenOptions
     public static KeyBinding pickingKeyBinding = null;
     public static KeyBindingComponent pickingKeyBindingComponent = null;
 
+    public static boolean queueReload = false;
+
     private float optionsScrollAmount = 0.0f;
     private float pagesListScrollAmount = 0.0f;
     private int top, bottom, optionsScrollRegionHeight, pagesListScrollRegionHeight, pageWidth, pagesListWidth;
@@ -57,6 +59,7 @@ public class ScreenOptions
     {
         super(parent);
         this.selectedPage = selectedPage;
+        queueReload = false;
     }
 
     @Override
@@ -95,6 +98,7 @@ public class ScreenOptions
         if (eventKey == Keyboard.KEY_ESCAPE)
         {
             mc.texturePackList.refreshIfReady(); // Sets the texturepacks on menu close
+            reloadIfReady();
             mc.displayScreen(getParentScreen());
         }
         else
@@ -149,6 +153,7 @@ public class ScreenOptions
         {
             mc.displayScreen(getParentScreen());
             mc.texturePackList.refreshIfReady(); // Sets the texturepacks on menu close
+            reloadIfReady();
         }
     }
 
@@ -160,6 +165,7 @@ public class ScreenOptions
         super.removed();
         mc.gameSettings.saveOptions();
         mc.texturePackList.refreshIfReady();
+        reloadIfReady();
     }
 
     private void scrollOptions(float amount) {
@@ -449,6 +455,7 @@ public class ScreenOptions
                     this.selectedPage.initComponents(mc);
                     mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
                     mc.texturePackList.refreshIfReady();
+                    reloadIfReady();
                     break;
                 }
                 pagesListY += PAGE_BUTTON_HEIGHT;
@@ -559,4 +566,11 @@ public class ScreenOptions
             mc.displayScreen(getParentScreen());
         }
     }
+
+    private void reloadIfReady() {
+        if (queueReload) {
+            mc.renderGlobal.loadRenderers();
+            queueReload = false;
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index a9a46b332..b8bd2f426 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -348,7 +348,7 @@ public abstract class OptionsPages
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.downloadSoundfiles))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.enableDevResourceLoading))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.devModels))
-//                .withComponent(new BooleanOptionComponent(mc.gameSettings.enableMultiDrawRendering))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.enableMultiDrawRendering))
             )
             .withComponent(new OptionsCategory("gui.options.page.debug.category.utility")
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
@@ -416,6 +416,7 @@ public abstract class OptionsPages
                     Minecraft.getMinecraft().hasCrashed = true;
                     throw new Error();
                 }))
+                .withComponent(new ShortcutComponent("gui.options.page.debug.button.garbage_collect", System::gc))
             );
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 52ce4d5c1..edb5f4137 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -16,6 +16,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.hud.component.HudComponents;
+import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.option.enums.Colorblindness;
 import net.minecraft.client.render.font.Fonts;
@@ -133,8 +134,7 @@ public class GameSettings {
 	public OptionBoolean alwaysShowDescriptions = new OptionBoolean(this, "alwaysShowDescriptions", false);
 	public OptionBoolean turnWithVehicle = new OptionBoolean(this, "turnWithVehicle", true);
 	public OptionBoolean disableCrashHandler = new OptionBoolean(this, "disableCrashHandler", false);
-	// Permanently disabled for 7.3 due to issues with render distance
-//	public OptionBoolean enableMultiDrawRendering = new OptionBoolean(this, "enableMultiDrawRendering", false);
+	public OptionBoolean enableMultiDrawRendering = new OptionBoolean(this, "enableMultiDrawRendering", false);
 
 	public OptionBoolean enableDevResourceLoading = new OptionBoolean(this, "enableDevResourceLoading", false);
 	public OptionBoolean downloadSoundfiles = new OptionBoolean(this, "downloadSoundfiles", true);
@@ -300,7 +300,7 @@ public class GameSettings {
 		loadOptions();
 		saveOptions();
 	}
-	
+
 	public String getDisplayString(Option<?> option) {
 		if (option == null) return "";
 		I18n trans = I18n.getInstance();
@@ -455,6 +455,13 @@ public class GameSettings {
 				mc.currentWorld.setDifficulty(difficulty.value, false);
 			}
 		}
+		if(option == renderDistance) {
+			if (mc.currentScreen instanceof ScreenOptions) {
+				ScreenOptions.queueReload = true;
+			} else {
+				mc.renderGlobal.loadRenderers();
+			}
+		}
 
 		if(option == playerLeftHanded && mc.thePlayer != null) {mc.thePlayer.playerConfig.setLeftHand(playerLeftHanded.value);}
 		if(option == playerCape && mc.thePlayer != null) {mc.thePlayer.playerConfig.setCape(playerCape.value);}
diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index da3ac9efc..24587ee2b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -58,6 +58,17 @@ public class FogManager {
         glFogfv(GL_FOG_COLOR, buffer(fogRed, fogGreen, fogBlue, 0.5F));
         glNormal3f(0.0F, -1F, 0.0F);
         glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        if (!mc.gameSettings.fog.value && fogMode != FOG_MODE_SKY) {
+            glFogi(GL_FOG_MODE, GL_EXP);
+            glFogf(GL_FOG_DENSITY, 0.0F);
+            float maxFogDistance = mc.gameSettings.renderDistance.highest * 16;
+            glFogf(GL_FOG_START, maxFogDistance * 0.25F);
+            glFogf(GL_FOG_END, maxFogDistance);
+            glEnable(GL_COLOR_MATERIAL);
+            glColorMaterial(GL_FRONT, GL_AMBIENT);
+            return;
+        }
+
         if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.currentWorld, Material.water, partialTick))
         {
             glFogi(GL_FOG_MODE, GL_EXP);
@@ -70,8 +81,8 @@ public class FogManager {
         }
         else
         {
-            float maxFogDistance = RenderDistance.EXTREME.chunks * 16;
             float fogDistance = farPlaneDistance;
+            float maxFogDistance = mc.gameSettings.renderDistance.highest * 16;
 
             float fogModifier = mc.currentWorld.getCurrentWeather() != null ? mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
             fogModifier = (1.0f - ((1.0f - fogModifier) * mc.currentWorld.weatherManager.getWeatherIntensity() * mc.currentWorld.weatherManager.getWeatherPower()));
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index c8c24a439..08720bee3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -6,6 +6,8 @@ import net.minecraft.client.entity.particle.Particle;
 import net.minecraft.client.entity.particle.ParticleDispatcher;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
+import net.minecraft.client.gui.options.ScreenOptions;
+import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.block.model.BlockModelLeaves;
 import net.minecraft.client.render.camera.EntityCamera;
@@ -259,6 +261,7 @@ public class RenderGlobal
     }
     public void loadRenderers()
     {
+        ScreenOptions.queueReload = false;
         updateStars();
         // Delete all display lists - this is a (hopefully temporary) workaround to AMD's OpenGL driver leaking memory
         // See https://community.amd.com/t5/opengl-vulkan/high-vram-consumption-in-minecraft/m-p/607299
@@ -1492,7 +1495,7 @@ public class RenderGlobal
         tessellator.draw();
         GL11.glEnable(GL11.GL_TEXTURE_2D);
     }
-    
+
     public void drawInterpolatedEntityBoundingBox(Entity entity, AABB boundingBox, ICamera camera, float partialTicks) {
         double cameraX = camera.getX(partialTicks);
         double cameraY = camera.getY(partialTicks);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index e9807a55e..3080645cf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -670,8 +670,8 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelEmpty<>(Blocks.SIGN_POST_PLANKS_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
         addDispatch(new BlockModelEmpty<>(Blocks.SIGN_WALL_PLANKS_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
         addDispatch(new BlockModelEmpty<>(Blocks.FLAG).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
-        addDispatch(new BlockModelEmpty<>(Blocks.SIGN_POST_PLANKS_OAK_PAINTED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
-        addDispatch(new BlockModelEmpty<>(Blocks.SIGN_WALL_PLANKS_OAK_PAINTED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
+        addDispatch(new BlockModelSignPainted<>(Blocks.SIGN_POST_PLANKS_OAK_PAINTED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
+        addDispatch(new BlockModelSignPainted<>(Blocks.SIGN_WALL_PLANKS_OAK_PAINTED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
 
         addDispatch(new BlockModelLayer<>(Blocks.LAYER_SNOW).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_snow"));
         addDispatch(new BlockModelLayer<>(Blocks.LAYER_LEAVES_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/leaves/oak_fancy"));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSignPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSignPainted.java
new file mode 100644
index 000000000..a6687f240
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSignPainted.java
@@ -0,0 +1,19 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicSignPainted;
+import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockModelSignPainted<T extends BlockLogicSignPainted> extends BlockModelEmpty<T>{
+    public BlockModelSignPainted(Block<T> block) {
+        super(block);
+    }
+
+    @Override
+    public @Nullable IconCoordinate getParticleTexture(@NotNull final Side side, final int meta) {
+        return BlockModelPlanksPainted.texCoords[this.block.getLogic().fromMetadata(meta).blockMeta];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index 97fe0b14f..f9337ba3f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -33,15 +33,25 @@ public abstract class EntityRenderer<T extends Entity>
     protected EntityRenderDispatcher renderDispatcher = null;
     protected Class<? extends T> appliedClass = null;
 
-    protected float shadowSize;
+    private float shadowSize;
     protected float shadowOpacity;
 
-    public EntityRenderer()
+    public EntityRenderer(final float shadowSize)
     {
-        this.shadowSize = 0.0F;
+        this.shadowSize = shadowSize;
         this.shadowOpacity = 1.0F;
     }
 
+    public EntityRenderer()
+    {
+        this(0.0f);
+    }
+
+    public float getShadowSize(final @NotNull T entity)
+    {
+        return this.shadowSize;
+    }
+
     public abstract void render(@NotNull Tessellator tessellator, @NotNull T entity, double x, double y, double z,
                                 float yaw, float partialTick);
 
@@ -145,12 +155,15 @@ public abstract class EntityRenderer<T extends Entity>
         final double lerpX = entity.xo + (entity.x - entity.xo) * (double)partialTick;
         final double lerpY = entity.yo + (entity.y - entity.yo) * (double)partialTick + (double)entity.getShadowHeightOffs();
         final double lerpZ = entity.zo + (entity.z - entity.zo) * (double)partialTick;
-        final int minX = MathHelper.floor(lerpX - (double) this.shadowSize);
-        final int maxX = MathHelper.floor(lerpX + (double) this.shadowSize);
-        final int minY = MathHelper.floor(lerpY - (double) this.shadowSize);
+
+        final float shadowSize = getShadowSize(entity);
+
+        final int minX = MathHelper.floor(lerpX - (double) shadowSize);
+        final int maxX = MathHelper.floor(lerpX + (double) shadowSize);
+        final int minY = MathHelper.floor(lerpY - (double) shadowSize);
         final int maxY = MathHelper.floor(lerpY);
-        final int minZ = MathHelper.floor(lerpZ - (double) this.shadowSize);
-        final int maxZ = MathHelper.floor(lerpZ + (double) this.shadowSize);
+        final int minZ = MathHelper.floor(lerpZ - (double) shadowSize);
+        final int maxZ = MathHelper.floor(lerpZ + (double) shadowSize);
         final double dxLerp = posX - lerpX;
         final double dyLerp = posY - lerpY;
         final double dzLerp = posZ - lerpZ;
@@ -165,7 +178,7 @@ public abstract class EntityRenderer<T extends Entity>
                     final int blockId = world.getBlockId(blockX, blockY - 1, blockZ);
                     if(blockId > 0 && world.getBlockLightValue(blockX, blockY, blockZ) > 3)
                     {
-                        renderShadowOnBlock(tessellator, entity, Blocks.blocksList[blockId], posX, posY + (double)entity.getShadowHeightOffs(), posZ, blockX, blockY, blockZ, opacity, this.shadowSize, dxLerp, dyLerp + (double)entity.getShadowHeightOffs(), dzLerp);
+                        renderShadowOnBlock(tessellator, entity, Blocks.blocksList[blockId], posX, posY + (double)entity.getShadowHeightOffs(), posZ, blockX, blockY, blockZ, opacity, shadowSize, dxLerp, dyLerp + (double)entity.getShadowHeightOffs(), dzLerp);
                     }
                 }
 
@@ -297,7 +310,7 @@ public abstract class EntityRenderer<T extends Entity>
 
     public void postRender(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick)
     {
-        if(renderShadows && this.renderDispatcher.settings.fancyGraphics.value == 1 && this.shadowSize > 0.0F)
+        if(renderShadows && this.renderDispatcher.settings.fancyGraphics.value == 1 && getShadowSize(entity) > 0.0F)
         {
             final double distance = this.renderDispatcher.distanceToLerpSquared(entity.x, entity.y, entity.z);
             final float opacity = (float)((1.0D - distance / 256D) * (double) this.shadowOpacity);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
index 5ecdc0d13..b7349c67c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
@@ -21,8 +21,7 @@ public class EntityRendererBoat extends EntityRenderer<EntityBoat>
     private final Minecraft mc = Minecraft.getMinecraft();
 
     public EntityRendererBoat() {
-        super();
-        this.shadowSize = 0.5F;
+        super(0.5f);
         this.flagRenderer = (TileEntityRendererFlag) (Object) TileEntityRenderDispatcher.instance.getRenderer(TileEntityFlag.class); // Definitely safe casting :)
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
index 47ef9d12c..06df18f9e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
@@ -23,8 +23,8 @@ public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBloc
 
     public EntityRendererFallingBlock()
     {
+        super(0.5f);
         mc = Minecraft.getMinecraft();
-        shadowSize = 0.5F;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererGeneric.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererGeneric.java
index c64d1ed24..62aa77466 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererGeneric.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererGeneric.java
@@ -9,8 +9,7 @@ import org.useless.dragonfly.models.entity.StaticEntityModel;
 public class EntityRendererGeneric<T extends Entity> extends EntityRenderer<T>{
     public final @NotNull StaticEntityModel entityModel;
     public EntityRendererGeneric(final @NotNull StaticEntityModel entityModel, final float shadowSize) {
-        super();
-        this.shadowSize = shadowSize;
+        super(shadowSize);
         this.entityModel = entityModel;
     }
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
index a4d01df79..c9861e379 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
@@ -19,7 +19,7 @@ public class EntityRendererItem extends EntityRenderer<EntityItem>
 
 
 	public EntityRendererItem() {
-		shadowSize = 0.15F;
+		super(0.15f);
 		shadowOpacity = 0.75F;
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
index 5c0f563c8..a4aa7d283 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
@@ -16,8 +16,7 @@ import org.lwjgl.opengl.GL12;
 
 public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
     public EntityRendererMinecart() {
-        super();
-        this.shadowSize = 0.5F;
+        super(0.5f);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
index 0055535fd..3121e5187 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
@@ -14,7 +14,7 @@ public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT>
 {
     public EntityRendererTNT()
     {
-        shadowSize = 0.5F;
+        super(0.5f);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index d97611bf1..ae44e7b9a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
+import net.minecraft.core.entity.AgedMob;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
@@ -25,8 +26,7 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T>{
     private static final Logger LOGGER = LogUtils.getLogger();
     private final @NotNull List<@Nullable StaticEntityModel> setupModels = new ArrayList<>();
     public MobRenderer(final float shadowSize) {
-        super();
-        this.shadowSize = shadowSize;
+        super(shadowSize);
     }
     @Override
     public void render(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
@@ -115,6 +115,24 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T>{
             }
             GL11.glRotatef(rotationProgress * getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
         }
+
+        if (entity instanceof AgedMob) {
+            final AgedMob agedMob = (AgedMob) entity;
+            final float ageScale = agedMob.getMobAge().getAgeScale();
+            GL11.glScalef(ageScale, ageScale, ageScale);
+        }
+    }
+
+    @Override
+    public float getShadowSize(final @NotNull T entity) {
+        final float baseSize = super.getShadowSize(entity);
+        if (entity instanceof AgedMob) {
+            final AgedMob agedMob = (AgedMob) entity;
+            final float ageScale = agedMob.getMobAge().getAgeScale();
+            return baseSize * ageScale;
+        }
+
+        return baseSize;
     }
 
     protected float getLimbSwing(final @NotNull T entity, final float partialTick) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
index 329e8e135..4a6dfa0e1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererChicken.java
@@ -4,6 +4,7 @@ import net.minecraft.core.entity.animal.MobChicken;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererQuadruped.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererQuadruped.java
index e2bc5c981..21007b1af 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererQuadruped.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererQuadruped.java
@@ -1,10 +1,12 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.core.entity.AgedMob;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.MobCow;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 3fdff365e..183cec6de 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -40,6 +40,8 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         final Block<?> block = tileEntity.getBlock();
         if (block == null || !(block.getLogic() instanceof BlockLogicSign)) return; // Check to make sure the block for the entity is present before rendering, some edge cases have the tile entity loaded before the block data and can cause a crash
 
+        GL11.glColor4f(1, 1, 1, 1);
+
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GL11.glPushMatrix();
 
